# PaperTrailActor Controller
# @author ToanDP <toandptech@gmail.com>
module PaperTrailActor
  module Controller
    extend ActiveSupport::Concern

    included do
      before_action :paper_trail_actor_info
    end

    def actor_paper_train
      PaperTrailActor::Actor.create
    rescue => e
      backtrace = e.backtrace.select{ |x| x.match(/#{::Rails.root.to_s}/) }.compact
      puts "CREATE_PAPER_TRAIL_ACTOR_ERROR: #{{message: e.message, backtrace: backtrace}.to_json}"
    end

    # Private methods
    private

    def paper_trail_actor_info
      PaperTrailActor::Actor.current_user = self.respond_to?('current_user') ? current_user : nil
      PaperTrailActor::Actor.current_request = request
      PaperTrailActor::Actor.controller_name = controller_name
      PaperTrailActor::Actor.action_name = action_name
    end
  end
end
